# Copyright (c) Microsoft Corporation. 
# Licensed under the MIT license. 

import math
import os
import sys
import glob
import gc
import threading

from pathlib import Path
from simplygon import simplygon_loader
from simplygon import Simplygon


def VertexColorCasting(sg: Simplygon.ISimplygon):
    sgSceneImporter = sg.CreateSceneImporter()
    sgSceneImporter.SetImportFilePath( "../Assets/RiggedSimplygonMan/RiggedSimplygonMan.fbx" )
    if not sgSceneImporter.RunImport():
        raise Exception("Failed to load RiggedSimplygonMan/RiggedSimplygonMan.fbx.")
    sgScene = sgSceneImporter.GetScene()

    # Create the aggregation processor. 
    sgAggregationProcessor = sg.CreateAggregationProcessor()

    sgAggregationProcessor.SetScene( sgScene )

    sgAggregationSettings = sgAggregationProcessor.GetAggregationSettings()
    sgMappingImageSettings = sgAggregationProcessor.GetMappingImageSettings()

    # Merge all geometries into a single geometry. 
    sgAggregationSettings.SetMergeGeometries( True )

    # Generates a mapping image which is used after the aggregation to cast new materials to the new 
    # aggregated object. 
    sgMappingImageSettings.SetGenerateMappingImage( True )
    sgMappingImageSettings.SetApplyNewMaterialIds( True )
    sgMappingImageSettings.SetGenerateTangents( True )
    sgMappingImageSettings.SetUseFullRetexturing( True )

    sgOutputMaterialSettings = sgMappingImageSettings.GetOutputMaterialSettings(0)

    # Setting the size of the output material for the mapping image. This will be the output size of the 
    # textures when we do material casting in a later stage. 
    sgOutputMaterialSettings.SetTextureWidth( 2048 )
    sgOutputMaterialSettings.SetTextureHeight( 2048 )

    # Start the aggregation process. 
    sgAggregationProcessor.RunProcessing()

    # Setup and run the vertex color material casting. 
    sgDiffuseCaster = sg.CreateVertexColorCaster()
    sgDiffuseCaster.SetMappingImage( sgAggregationProcessor.GetMappingImage() )
    sgDiffuseCaster.SetSourceMaterials( sgScene.GetMaterialTable() )
    sgDiffuseCaster.SetSourceTextures( sgScene.GetTextureTable() )
    sgDiffuseCaster.SetScene( sgScene )

    sgDiffuseCasterSettings = sgDiffuseCaster.GetVertexColorCasterSettings()
    sgDiffuseCasterSettings.SetMaterialChannel( "Diffuse" )
    sgDiffuseCasterSettings.SetOutputColorName( "DiffuseAsVertexColor" )

    sgDiffuseCaster.RunProcessing()

    # Update scene with new casted vertex colors. 
    sgMaterialTable = sg.CreateMaterialTable()
    sgTextureTable = sg.CreateTextureTable()
    sgMaterial = sg.CreateMaterial()
    sgDiffuseAsVertexColorColorShadingNode = sg.CreateShadingColorNode()
    sgDiffuseAsVertexColorColorShadingNode.SetColor( 1.0, 1.0, 1.0, 1.0 )

    sgMaterial.AddMaterialChannel( "DiffuseAsVertexColor" )
    sgMaterial.SetShadingNetwork( "DiffuseAsVertexColor", sgDiffuseAsVertexColorColorShadingNode )

    sgMaterialTable.AddMaterial( sgMaterial )

    sgScene.GetTextureTable().Clear()
    sgScene.GetMaterialTable().Clear()
    sgScene.GetTextureTable().Copy(sgTextureTable)
    sgScene.GetMaterialTable().Copy(sgMaterialTable)

    sgSceneExporter = sg.CreateSceneExporter()
    sgSceneExporter.SetScene(sgScene)
    sgSceneExporter.SetExportFilePath( "Output.fbx" )
    if not sgSceneExporter.RunExport():
        raise Exception("Failed to save Output.fbx.")


if __name__ == '__main__':
    sg = simplygon_loader.init_simplygon()

    VertexColorCasting(sg)

    sg = None
    gc.collect()

